<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>gateway documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">gateway documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content guard">
                   <div class="content-data">









<ol class="breadcrumb">
    <li>Guards</li>
    <li>SocialAccountGuard</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
        <div class="tab-pane fade active in" id="c-info">
            <p class="comment">
            <h3>File</h3>
            </p>
            <p class="comment">
                <code>src/services/auth/social/social-account.guard.ts</code>
            </p>





                <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Readonly</span>
                                <a href="#fb_app_id">fb_app_id</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Readonly</span>
                                <a href="#fb_app_secret">fb_app_secret</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Readonly</span>
                                <a href="#fbAPIDebugEndpoint">fbAPIDebugEndpoint</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Readonly</span>
                                <a href="#fbAPIEndpoint">fbAPIEndpoint</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Readonly</span>
                                <a href="#key">key</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Readonly</span>
                                <a href="#logger">logger</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Readonly</span>
                                <a href="#redirect_uri">redirect_uri</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#canActivate">canActivate</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

                <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(authService: <a href="../injectables/AuthService.html">AuthService</a>, usersService: <a href="../injectables/UsersService.html">UsersService</a>)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="23" class="link-to-prism">src/services/auth/social/social-account.guard.ts:23</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>authService</td>
                                                  
                                                        <td>
                                                                        <code><a href="../injectables/AuthService.html" target="_self" >AuthService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>usersService</td>
                                                  
                                                        <td>
                                                                        <code><a href="../injectables/UsersService.html" target="_self" >UsersService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

                <section>
    
    <h3 id="methods">
        Methods
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="canActivate"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            canActivate
                        </b>
                        <a href="#canActivate"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>canActivate(context: ExecutionContext)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="34"
                            class="link-to-prism">src/services/auth/social/social-account.guard.ts:34</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>context</td>
                                    <td>
                                            <code>ExecutionContext</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>{}</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
</section>
        </div>


        <div class="tab-pane fade  tab-source-code" id="c-source">
            <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { createHmac } from &#x27;crypto&#x27;
import { Injectable, UnauthorizedException, BadRequestException, Logger, CanActivate, ExecutionContext } from &#x27;@nestjs/common&#x27;
import { PassportStrategy } from &#x27;@nestjs/passport&#x27;
import { Strategy } from &#x27;passport-local&#x27;
import { AuthService } from &#x27;../auth.service&#x27;
import axios from &#x27;axios&#x27;
import { UsersService } from &#x27;../../users/services/users.service&#x27;
import firebase from &#x27;firebase-admin&#x27;
import multer from &#x27;multer&#x27;
import { Request } from &#x27;express&#x27;

@Injectable()
export class SocialAccountGuard implements CanActivate {
    private readonly logger &#x3D; new Logger(SocialAccountGuard.name)
    private readonly key: string
    private readonly fbAPIEndpoint &#x3D;
        // &#x27;https://graph.facebook.com/v7.0/oauth/access_token?&#x27;
        &#x27;https://graph.facebook.com/oauth/access_token?&#x27;
    private readonly fbAPIDebugEndpoint &#x3D;
        &#x27;https://graph.facebook.com/v7.0/debug_token?&#x27;
    private readonly fb_app_id: string
    private readonly fb_app_secret: string
    private readonly redirect_uri &#x3D; &#x60;${process.env.API_URL}auth/social-login&#x60;

    constructor(
        private authService: AuthService,
        private usersService: UsersService,
    ) {
        this.key &#x3D; process.env.ACCOUNT_KEY
        this.fb_app_id &#x3D; process.env.FACEBOOK_APP_ID
        this.fb_app_secret &#x3D; process.env.FACEBOOK_APP_SECRET
    }

    async canActivate(context: ExecutionContext) {
        // : boolean | Promise&lt;boolean&gt; | Observable&lt;boolean&gt; {
        try {
            const request: Request &#x3D; context.switchToHttp().getRequest()

            // const postMulterRequest &#x3D; await new Promise((resolve, reject) &#x3D;&gt; {
            //     // multer().any()(request, {}, function (err) {
            //     // @ts-ignore
            //     multer().any()(request, {}, function (err) {
            //         if (err) reject(err)
            //         resolve(request)
            //     })
            // })

            let { user_id, access_token, social_provider } &#x3D; request.body

            if (user_id &#x3D;&#x3D;&#x3D; undefined ||
                access_token &#x3D;&#x3D;&#x3D; undefined ||
                social_provider &#x3D;&#x3D;&#x3D; undefined) {
                let headers &#x3D; request.headers
                user_id &#x3D; headers.user_id
                access_token &#x3D; headers.access_token
                social_provider &#x3D; headers.social_provider
            }

            if ((social_provider as string).toLowerCase() &#x3D;&#x3D;&#x3D; &#x27;facebook&#x27;) {

                let debug_url &#x3D; &#x60;${this.fbAPIDebugEndpoint}input_token&#x3D;${access_token}&amp;access_token&#x3D;${this.fb_app_id}|${this.fb_app_secret}&#x60;

                let response &#x3D; await axios.get(debug_url)
                let data &#x3D; await response.data.data

                const isEmpty &#x3D;
                    Object.getOwnPropertyNames(data).length &#x3D;&#x3D;&#x3D; 0

                if (isEmpty ||
                    !data.is_valid ||
                    data.app_id !&#x3D;&#x3D; this.fb_app_id) {
                    // throw new UnauthorizedException()
                    this.logger.debug(&#x60;Missing properties or app_id doesn&#x27;t match&#x60;)
                    return false
                }

                let firebase_data &#x3D; await firebase.auth().getUser(user_id)

                if (!firebase_data ||
                    firebase_data &#x3D;&#x3D;&#x3D; undefined ||
                    firebase_data.providerData.length &lt;&#x3D; 0) {
                        this.logger.debug(&#x60;Missing firebase data&#x60;)
                    return false
                }

                let fb &#x3D;
                    firebase_data.providerData.find(f &#x3D;&gt;
                        f.providerId &#x3D;&#x3D;&#x3D; &#x27;facebook.com&#x27;)

                if (fb &#x3D;&#x3D;&#x3D; undefined ||
                    fb.uid !&#x3D;&#x3D; data.user_id) {
                        this.logger.debug(&#x60;Missing uid attached to Facebook object or it doesn&#x27;t match user id&#x60;)
                    return false
                }

                if (this.key &#x3D;&#x3D;&#x3D; undefined || this.key.length &lt;&#x3D; 0) {
                    this.logger.error(&#x27;Key for signing credentials is not available&#x27;)
                    throw new BadRequestException()
                }

                const user &#x3D;
                    await this.usersService.findOneByDocument(user_id)

                if (!user) {
                    this.logger.debug(&#x60;User wasn&#x27;t found&#x60;)
                    // throw new UnauthorizedException()
                    return false
                }
                // return user

                // // request.body &#x3D; JSON.parse(JSON.stringify(request.body))
                // let keys &#x3D; Object.keys(request.body)
                // keys.forEach(f &#x3D;&gt; {
                //     request.body[f] &#x3D; JSON.parse(request.body[f])
                // })

                return true
            }

            throw new UnauthorizedException()

        } catch (error) {
            console.debug(error)
            this.logger.error(error)
            // return null
            // throw new UnauthorizedException()
            return false
        }
    }
}</code></pre>
        </div>
</div>





                   




                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'guard';
            var COMPODOC_CURRENT_PAGE_URL = 'SocialAccountGuard.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
